/*
 * Copyright 2013 Mark Slater
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package net.sourceforge.writexml;

public final class Cdata extends UnaryMicrotype<char[]> implements TextContent {

    private Cdata(final char[] value) {
        super(value);
    }

    public static Cdata cdata(final String text) {
        return new Cdata(text.toCharArray());
    }

    public void writeTo(final XmlWriter xmlWriter) throws XmlWriterException {
        xmlWriter.writeCdata(value);
    }
}
